VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmEmbedded_search 
   Caption         =   "Embedded Search"
   ClientHeight    =   1770
   ClientLeft      =   1560
   ClientTop       =   1515
   ClientWidth     =   5775
   Icon            =   "EMB_SRCH.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1770
   ScaleWidth      =   5775
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ProgressBar SSPnl_Progress 
      Height          =   375
      Left            =   225
      TabIndex        =   2
      Top             =   675
      Width           =   5505
      _ExtentX        =   9710
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   2295
      TabIndex        =   0
      Top             =   1215
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Searching database..."
      Height          =   315
      Left            =   1320
      TabIndex        =   1
      Top             =   240
      Width           =   2835
   End
End
Attribute VB_Name = "frmEmbedded_search"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Start_length  As Long
Private Search_type As String
Private Number_processed As Long

Private Sub cmdCancel_Click()
    Unload Me
                        
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub


Private Sub Form_Activate()
    On Local Error GoTo Error_handler
    Me.Refresh
    Start_length = 0
    Number_processed = 0
    Begin_search
    Unload Me
                        
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume


End Sub

Private Sub Begin_search()
    Dim mySQL As String
    Dim Search_string As String
    Search_string = frmSearch.txtSearch_string.Text
    
    Initialise_working_database
    success = Build_recordset
    
    If success = False Then
        buttons = vbExclamation + vbOKOnly
        MsgBox "Match not found", buttons, "Embedded Search"
        Exit Sub
    Else
        Column$ = Determine_column
        Do
            If Not (Embedded_in(Search_recordset(Column$), Search_string)) Then
                Search_recordset.Delete
            End If
            Report_progress
            Me.Refresh
            DoEvents 'allow the user to stop the search
            Search_recordset.MoveNext
        Loop Until Search_recordset.EOF
        
        If Search_recordset.RecordCount = 0 Then
            buttons = vbExclamation + vbOKOnly
            MsgBox "Match not found", buttons, "Embedded Search"
        Else
            Current_list_index = frmSearch.cboSearch_on.ListIndex
            frmSearch_results.Tag = Search_type
            frmSearch_results.Show
        End If
        
    End If
End Sub

Private Function Determine_SQL() As String
    
    Dim Working_db_path As String
    Working_db_path = Get_ini_data("working_path")
        
    Select Case frmSearch.cboSearch_on.ListIndex
        Case 0, 1, 2, 3
            mySQL = "Select *" _
                    & "INTO [Search] IN '" + Working_db_path + "'" _
                    & "FROM [Subscriber table]; "
            Search_type = "Subscriber"
        Case Else
            mySQL = "Select [Books table].*, " _
                    & "[Books borrowed table].[subscriber id] as [Out to], " _
                    & "[Books borrowed table].[Date borrowed], " _
                    & "[Books borrowed table].[Date due], " _
                    & "[Books requested table].[subscriber id] as [Requested by], " _
                    & "[Books requested table].[Date requested], " _
                    & "[Books requested table].[Expiry Date] " _
                    & "INTO [Search] IN '" + Working_db_path + "'" _
                    & "FROM [Books requested table] right join ([Books table] LEFT JOIN [Books borrowed table] " _
                    & "ON [Books table].[Book number] = [Books borrowed table].[Book number])  ON [books requested table].[book number] = [Books table].[book number]; "
            Search_type = "Book"
    End Select
    Determine_SQL = mySQL

End Function

Public Function Build_recordset() As Boolean
    
    Query.SQL = Determine_SQL
    Query.Execute
    Set Search_recordset = Working_database.OpenRecordset("Search", dbOpenTable)
    
    
    If Search_recordset.RecordCount = 0 Then
        Build_recordset = False
    Else
        Build_recordset = True
        Search_recordset.MoveLast
        Search_recordset.MoveFirst
        Start_length = Search_recordset.RecordCount
    End If
        
    
    
End Function

Private Function Determine_column()
    Dim Column As String
    Select Case frmSearch.cboSearch_on.ListIndex
        Case 0
            'Subscriber ID
            Column = "Subscriber ID"
        Case 1
            'Subscriber surname
            Column = "Surname"
        Case 2
            'Subscriber Initials
            Column = "Initials"
        Case 3
            'Subscriber title
            Column = "Subscriber title"
        Case 4
            'Book number
            Column = "Book number"
        Case 5
            'Book author
            Column = "Book author"
        Case 6
            'Book title
            Column = "Book title"
    End Select
    Determine_column = Column
End Function

Private Function Embedded_in(Master_string As String, Search_string As String) As Boolean
    Embedded_in = False
    
    If Len(Master_string) >= Len(Search_string) Then
        
        For Counter = 1 To (Len(Master_string) - Len(Search_string) + 1)
            Under_test$ = Mid(Master_string, Counter, Len(Search_string))
            If Compare_text(Under_test$, Search_string) Then
                Embedded_in = True
                Exit For
            End If
        Next
    
    End If

End Function

Private Sub Report_progress()

    Number_processed = Number_processed + 1
    progress = Int((Number_processed / Start_length) * 100)
    SSPnl_Progress.Value = progress
    
End Sub

Private Sub Initialise_working_database()
    On Local Error GoTo error_solver
    Dim Working_db_path As String
    Working_db_path = Get_ini_data("working_path")
    
    
    'Ensure that database is not open
    On Local Error Resume Next
    Working_database.Close
    On Local Error GoTo error_solver
    
    
    'Delete the database if it exists
    If Dir(Working_db_path) <> "" Then
        Kill (Working_db_path)
    End If
    
    Set Working_database = MyWorkspace.CreateDatabase _
         (Working_db_path, dbLangGeneral, dbEncrypt)
    On Local Error GoTo 0
    
Exit Sub
    
error_solver:
    Err.Raise Err.Number
Resume

End Sub
