Attribute VB_Name = "General_report_procedures_and_declations"
Attribute VB_Description = "Report general functions and declarations"

Public Running_report As Boolean
Public Running_mail_merge As Boolean
Public Running_text As Boolean
Public Exit_report As Boolean

Public Current_menu_items As Integer
Public Start_search_position As Integer
Public Search_and_replace_flag As Boolean
Public Query_file As String
Public myTemp As String

Public Already_working As Boolean



Public Sub Initialise_System()
    Dim MyText As String
    
    MyText = ""
    Declare_formats
    
    frmReport.Refresh
    frmSession.Show 1
    frmReport.txtReport.Text = ""
    frmReport.Caption = "Librarius' Report Maker"
    
    If Running_mail_merge Then
        frmReport.mnuMail_merge.Visible = True
        frmReport.mnuReport.Visible = False
        frmReport.pnlSession.Caption = "Merge letter Session    "
        MyText = Get_file_contents
        If MyText <> "" Then
            If Syntax_check(MyText) Then
                If Compile_sql(MyText) Then
                    Load_insert_field_menu
                    Exit Sub
                End If
            End If
        End If
    ElseIf Running_report Then
        frmReport.mnuReport.Visible = True
        frmReport.mnuMail_merge.Visible = False
        frmReport.pnlSession.Caption = "Report Session    "
        MyText = Get_file_contents
        If MyText <> "" Then
            If Syntax_check(MyText) Then
                If Compile_sql(MyText) Then
                    Exit Sub
                End If
            End If
        End If
    ElseIf Running_text Then
        frmReport.mnuMail_merge.Visible = False
        frmReport.mnuReport.Visible = False
        frmReport.pnlSession.Caption = "Text editing    "
        Exit Sub
    Else
        Log_out_user
        End
    End If

    
    'Error must have occured if the module was not exited before this
    'stage so load the default TEXT EDITING mode.
    msg$ = "Loading default Text Editing session"
    MsgBox msg$, vbInformation, "Report Maker"
    frmReport.mnuMail_merge.Visible = False
    frmReport.mnuReport.Visible = False
    Running_mail_merge = False
    Running_report = False
    frmReport.pnlSession.Caption = "Text editing    "
    
    

End Sub


Public Function Embedded_in(Start As Integer, Master_string As String, Search_string As String) As Integer
    
    Embedded_in = 0
    If Len(Search_string) = 0 Then Exit Function
    
    If Len(Master_string) >= Len(Search_string) Then
        For Counter = Start To (Len(Master_string) - Len(Search_string) + 1)
            Under_test$ = Mid(Master_string, Counter, Len(Search_string))
            If UCase$(Under_test$) = UCase(Search_string) Then
                If Consider_case(Under_test$, Search_string) And _
                  Consider_whole_word(Counter, Master_string, Search_string) _
                  Then
                    Embedded_in = Counter
                    Exit For
                End If
            End If
        Next
    
    End If
    
End Function


Public Sub Find_next()
    Dim Position As Integer
    
    Master_string$ = frmReport.txtReport.Text
    Search_string$ = frmFind_text.txtFind_Text.Text
    
    If Embedded_in(Start_search_position, Master_string$, Search_string$) = 0 Then
        MsgBox "Match not found", vbExclamation, "Find Text"
        
    Else
        Position = Embedded_in(Start_search_position, Master_string$, Search_string$)
        Start_search_position = Position + Len(Search_string$)
        frmReport.txtReport.SelStart = Position - 1
        frmReport.txtReport.SelLength = Len(Search_string$)
        
    End If
        
End Sub

Public Function Consider_whole_word(Counter As Long, Master_string As String, Search_string As String) As Boolean
    Dim Before As Boolean
    Dim After As Boolean
    Dim myForm As Object
    
    If Search_and_replace_flag = True Then
        Set myForm = frmSearch_and_replace
    Else
        Set myForm = frmFind_text
    End If
    
    If myForm.chkWholeWord.Value = Checked Then
        
        Select Case Mid(Master_string, Counter - 1, 1)
            Case Chr(13), Chr$(10), Chr$(9), Chr(32)
                Before = True
        End Select
        
        Select Case Mid(Master_string, Counter + Len(Search_string), 1)
            Case Chr(13), Chr$(10), Chr$(9), Chr(32)
                After = True
        End Select
        
        If Before And After Then
            Consider_whole_word = True
        Else
            Consider_whole_word = False
        End If
    Else
        Consider_whole_word = True
    End If
    
End Function

Public Function Consider_case(Under_test As String, Search_string As String) As Boolean
    
    Dim myForm As Object
    
    If Search_and_replace_flag = True Then
        Set myForm = frmSearch_and_replace
    Else
        Set myForm = frmFind_text
    End If
    
    If myForm.chkCaseSensitive.Value = Checked Then
        If Under_test = Search_string Then
            Consider_case = True
        Else
            Consider_case = False
        End If
    Else
        Consider_case = True
    End If
            
End Function

Public Function Get_file_contents() As String
    Dim Temp As String
    Temp = ""
    On Local Error GoTo Error_handler
    With frmReport.MyDialogue
        .FileName = ""
        .DialogTitle = "Set Query Text File"
        .Filter = "SQL Files (*.sql)|*.sql|Text Files (*.TXT)|*.txt"
        .FilterIndex = 1
        .Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
        .CancelError = True
        .ShowOpen
    End With
    
    
    
    myFileName$ = frmReport.MyDialogue.FileName
    If FileLen(myFileName$) > 30000 Then
        msg$ = "This file is too long to be opened as a query."
        Buttons = vbOKOnly + vbExclamation
        MsgBox msg$, Buttons, "Open SQL File"
    Else
        myHandle = FreeFile
        Open myFileName$ For Input As myHandle
            myTemp = ""
            Do
                Line Input #myHandle, Temp
                myTemp = myTemp + Temp + Chr$(13) + Chr$(10)
                If EOF(myHandle) Then Exit Do
            Loop
        Get_file_contents = myTemp
        Close myHandle
        
    End If
        
Exit Function

Error_handler:
    If Err.Number = cdlCancel Then
        Get_file_contents = ""
        Exit Function
    Else
        Err.Raise Err.Number
    End If
Resume

End Function

Public Function Syntax_check(Sql_text As String)
    
    mySQL = UCase(Trim(Sql_text))
    If Mid(mySQL, 1, 1) = Chr$(34) Then
        mySQL = Mid(mySQL, 2, Len(mySQL) - 1)
    End If
    
    If Mid(mySQL, Len(mySQL), 1) = Chr$(34) Then
        mySQL = Mid(mySQL, 1, Len(mySQL) - 1)
    End If
    
    
    If Left(mySQL, 6) <> "SELECT" Then
        msg$ = "SQL must start with SELECT"
    ElseIf InStr(1, mySQL, " INTO ", 1) <> 0 Then
        msg$ = "You cannot specify a make table query."
    End If
    
    If msg$ <> "" Then
        Buttons = vbOKOnly + vbExclamation
        MsgBox msg$, Buttons, "Protocol Error"
        Syntax_check = False
    Else
        Syntax_check = True
    End If
        
End Function

Public Function Compile_sql(mySQL As String)
    Dim First_try As Boolean
    Let First_try = True
    
    mySQL = Trim(UCase(mySQL))
    If Mid(mySQL, 1, 1) = Chr$(34) Then
        mySQL = Mid(mySQL, 2, Len(mySQL) - 1)
    End If

        
    If Mid(mySQL, Len(mySQL), 1) = Chr$(34) Then
        mySQL = Mid(mySQL, 1, Len(mySQL) - 1)
    End If
    
    
    On Local Error GoTo ErrorHandler
    Set Report_query = Libra.QueryDefs("Report Query Object")
    Report_query.SQL = mySQL
    Set SQL_result = Report_query.OpenRecordset()
    If SQL_result.RecordCount = 0 Then
        msg$ = "This Query did not return any records."
        Buttons = vbExclamation + vbOKOnly
        MsgBox msg$, Buttons, "Open Query File"
        Compile_sql = False
    Else
        SQL_result.MoveLast
        SQL_result.MoveFirst
        Compile_sql = True
    End If
        
    On Local Error GoTo 0

Exit Function

ErrorHandler:
    If First_try And Err.Number = 3078 Then
        'The table is first checked in the main database and if it is not
        'found, another search is carried out in the transaction DB before
        'the table is registered as non-existend.
        Set Report_query = Transaction_db.QueryDefs("Report Query Object")
        First_try = False
        Report_query.SQL = mySQL
        Resume
    End If
    Compile_sql = False
    msg$ = "Compiling Error : " + Err.description
    Buttons = vbOKOnly + vbExclamation
    MsgBox msg$, Buttons, "Error"
    Exit Function
Resume

    
End Function


Public Function Get_trimmed_total() As Integer
    
    Dim Total As Long
    Dim myValue As Long
    Already_working = True
    
    
    For Counter = 1 To (frmTrim_fields.Grid1.Rows - 1)
        frmTrim_fields.Grid1.Col = 2
        frmTrim_fields.Grid1.Row = Counter
        If Trim(frmTrim_fields.Grid1.Text) = "Yes" Then
            frmTrim_fields.Grid1.Col = 4
            If Val(frmTrim_fields.Grid1.Text) <> 0 Then
                myValue = Val(frmTrim_fields.Grid1.Text)
                myValue = myValue
            Else
                frmTrim_fields.Grid1.Col = 3
                myValue = Val(frmTrim_fields.Grid1.Text)
            End If
            Total = Total + myValue
        End If
    Next
    
    Get_trimmed_total = Total
    Already_working = False
    


End Function


Public Sub Load_insert_field_menu()
    'The Current_menu_items variable is used to store the number of
    'menu items created at run time using the load statement
    
    'Remove currently displayed items if any
    If Current_menu_items <> 0 Then
        For Counter = 1 To Current_menu_items
            Unload frmReport.mnuField_name(Counter)
        Next
    End If
    
    'Load new field names
    frmReport.mnuField_name(0).Caption = SQL_result.Fields(0).Name
    If SQL_result.Fields.Count > 1 Then
        For Counter = 1 To SQL_result.Fields.Count - 1
            Load frmReport.mnuField_name(Counter)
            frmReport.mnuField_name(Counter).Caption = SQL_result.Fields(Counter).Name
        Next
    End If
    
    Current_menu_items = SQL_result.Fields.Count - 1
    
End Sub

Public Sub Set_printer_to_custom_font()
    
    With Printer
        .FontName = frmReport.txtReport.FontName
        .FontSize = frmReport.txtReport.FontSize
        .FontBold = frmReport.txtReport.FontBold
        .FontItalic = frmReport.txtReport.FontBold
    End With
    
End Sub

Public Sub Set_printer_to_default_font()
    
    With Printer
        .FontBold = False
        .FontItalic = False
        .FontSize = 12
    End With
    
End Sub
    
